## jacktrip 1.7.0+ds

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)
set(CMAKE_OSX_DEPLOYMENT_TARGET 10.14)
set(CMAKE_CXX_STANDARD 17)
project(QJackTrip)

set(nogui FALSE)
set(rtaudio TRUE)
set(weakjack TRUE)
set(novs FALSE)
set(noupdater FALSE)
set(psi FALSE)
set(QtVersion "5")

if (${QtVersion} MATCHES "5")
  set(CMAKE_OSX_DEPLOYMENT_TARGET 10.13)
  set(CMAKE_OSX_ARCHITECTURES arm64;x86_64)
endif ()

message(STATUS "Hello Aaron! For anyone else, heed the following warning:")
message(WARNING "The CMake build of JackTrip is currently NOT officially supported. Meson or QMake are recommended for a full featured build."
        "https://jacktrip.github.io/jacktrip/Build/Meson_build/")

if (nogui)
  add_compile_definitions(NO_GUI)
  set(novs TRUE)
  set(noupdater TRUE)
endif ()

if (psi)
  set(novs TRUE)
endif ()

if (novs)
  add_compile_definitions(NO_VS)
  set(QRC_FILE "src/gui/qjacktrip_novs.qrc")
else ()
  set(QRC_FILE "src/gui/qjacktrip.qrc")
endif ()

if (noupdater)
  add_compile_definitions(NO_UPDATER)
endif ()

if (psi)
  add_compile_definitions(PSI)
  if (novs)
    add_compile_definitions(BUILD_TYPE="psi-borg.org NO_VS binary")
  else ()
    add_compile_definitions(BUILD_TYPE="psi-borg.org binary")
  endif ()

  file(READ "${QRC_FILE}" QRC_CONTENTS)
  string(REPLACE "<file>about@2x.png" "<file alias=\"about@2x.png\">alt/about@2x.png" QRC_CONTENTS "${QRC_CONTENTS}")
  string(REPLACE "<file>about.png" "<file alias=\"about.png\">alt/about.png" QRC_CONTENTS "${QRC_CONTENTS}")
  string(REPLACE "<file>icon.png" "<file alias=\"icon.png\">alt/icon.png" QRC_CONTENTS "${QRC_CONTENTS}")
  file(WRITE "${QRC_FILE}" "${QRC_CONTENTS}")
  string(TIMESTAMP BUILD_DATE "%Y%m%d")
  set(BUILD_NUMBER "00")
  add_compile_definitions(BUILD_ID="${BUILD_DATE}${BUILD_NUMBER}")
  add_compile_definitions(NDEBUG)
else ()
  file(READ "${QRC_FILE}" QRC_CONTENTS)
  string(REPLACE "<file alias=\"about@2x.png\">alt/about@2x.png" "<file>about@2x.png" QRC_CONTENTS "${QRC_CONTENTS}")
  string(REPLACE "<file alias=\"about.png\">alt/about.png" "<file>about.png" QRC_CONTENTS "${QRC_CONTENTS}")
  string(REPLACE "<file alias=\"icon.png\">alt/icon.png" "<file>icon.png" QRC_CONTENTS "${QRC_CONTENTS}")
  file(WRITE "${QRC_FILE}" "${QRC_CONTENTS}")
endif ()

add_compile_definitions(QT_OPENSOURCE)

if (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
  set (ENV{PKG_CONFIG_PATH} "/usr/local/lib/pkgconfig")
elseif (${CMAKE_SYSTEM_NAME} MATCHES "Windows")
  add_compile_definitions(_WIN32_WINNT=0x0600 WIN32_LEAN_AND_MEAN)
  if (EXISTS "C:/Program Files/JACK2/include")
    include_directories("C:/Program Files/JACK2/include")
    set (jacklib "C:/Program Files/JACK2/lib/libjack64.lib")
  else ()
    include_directories("C:/Program Files (x86)/Jack/includes")
    set (jacklib "C:/Program Files (x86)/Jack/lib/libjack64.lib")
  endif ()
  file(GLOB QtDirs "C:/Qt/${QtVersion}.*.*/mingw*_64")
  list(GET QtDirs 0 QtDir)
  message(STATUS "Using Qt found at ${QtDir}")
  set (CMAKE_PREFIX_PATH "${QtDir}")
  if (rtaudio)
    include_directories("C:/Program Files (x86)/RtAudio/include")
    set (rtaudiolib "C:/Program Files (x86)/RtAudio/lib/librtaudio.dll.a")
  endif ()
endif ()

string(PREPEND QtVersion "Qt")

if (${CMAKE_SYSTEM_NAME} MATCHES "Linux" OR ${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
  find_package(PkgConfig REQUIRED)
  pkg_check_modules(JACK REQUIRED IMPORTED_TARGET jack)
  if (weakjack)
    # On mac, weakjack doesn't find jack unless this is explicitly included.
    include_directories(${JACK_INCLUDE_DIRS})
  endif ()
  if (rtaudio)
    pkg_check_modules(RTAUDIO REQUIRED IMPORTED_TARGET rtaudio)
  endif ()
endif ()

#set_property(SOURCE src/Regulator.h PROPERTY SKIP_AUTOGEN ON)
# Find includes in corresponding build directories
set(CMAKE_INCLUDE_CURRENT_DIR ON)
# Instruct CMake to run moc automatically when needed.
set(CMAKE_AUTOMOC ON)
# Instruct CMake to create code from Qt designer ui files
set(CMAKE_AUTOUIC ON)

set(CMAKE_AUTORCC ON)

# Find the QtWidgets library
if (NOT nogui)
  find_package(${QtVersion}Widgets CONFIG REQUIRED)
  if (NOT novs)
    find_package(${QtVersion}Quick CONFIG REQUIRED)
    find_package(${QtVersion}NetworkAuth CONFIG REQUIRED)
    find_package(${QtVersion}WebSockets CONFIG REQUIRED)
  endif ()
endif ()
find_package(${QtVersion}Network CONFIG REQUIRED)

set(qjacktrip_SRC
  src/main.cpp
  src/Settings.cpp
  src/jacktrip_globals.cpp
  src/JackTrip.cpp
  src/UdpHubListener.cpp
  src/JackTripWorker.cpp
  src/DataProtocol.cpp
  src/UdpDataProtocol.cpp
  src/AudioInterface.cpp
  src/JackAudioInterface.cpp
  src/JMess.cpp
  src/LoopBack.cpp
  src/PacketHeader.cpp
  src/RingBuffer.cpp
  src/JitterBuffer.cpp
  src/Regulator.cpp
  src/Compressor.cpp
  src/Limiter.cpp
  src/Reverb.cpp
  src/AudioTester.cpp
  src/Patcher.cpp
  src/SslServer.cpp
  src/Auth.cpp
  src/ProcessPlugin.cpp
)

if (rtaudio)
  add_compile_definitions(RT_AUDIO)
  set (qjacktrip_SRC ${qjacktrip_SRC}
    src/RtAudioInterface.cpp
  )
endif ()

if (weakjack)
  add_compile_definitions(USE_WEAK_JACK)
  include_directories("externals/weakjack")
  set (qjacktrip_SRC ${qjacktrip_SRC}
    externals/weakjack/weak_libjack.c
  )
endif ()

if (NOT nogui)
  set (qjacktrip_SRC ${qjacktrip_SRC}
    src/gui/qjacktrip.cpp
    src/gui/about.cpp
    src/gui/messageDialog.cpp
    src/gui/textbuf.cpp
    src/gui/vuMeter.cpp
    src/Meter.cpp
  )
  
  if (NOT novs)
    set (qjacktrip_SRC ${qjacktrip_SRC}
      src/gui/virtualstudio.cpp
      src/gui/vsQuickView.cpp
      src/gui/vsServerInfo.cpp
      src/gui/vsPing.cpp
      src/gui/vsPinger.cpp
      src/gui/vsDevice.cpp
      src/gui/vsAudioInterface.cpp
      src/gui/vsUrlHandler.cpp
      src/gui/vsWebSocket.cpp
      src/gui/vsPermissions.cpp
      src/gui/qjacktrip.qrc
      src/Volume.cpp
      src/Tone.cpp
      # Need to include this for AUTOMOC to do its thing
      src/JTApplication.h
      src/gui/vsQmlClipboard.h
    )
    if (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
      set (qjacktrip_SRC ${qjacktrip_SRC} src/gui/vsMacPermissions.mm)
    endif ()
  else ()
    set (qjacktrip_SRC ${qjacktrip_SRC} src/gui/qjacktrip_novs.qrc)
  endif ()
  
  if (NOT noupdater)
    set (qjacktrip_SRC ${qjacktrip_SRC}
      src/dblsqd/feed.cpp
      src/dblsqd/release.cpp
      src/dblsqd/semver.cpp
      src/dblsqd/update_dialog.cpp
    )
  endif ()

  if (${CMAKE_SYSTEM_NAME} MATCHES "Windows")
    file(READ "win/qjacktrip.rc" RC_CONTENTS)
    if (psi)
      string(REPLACE "jacktrip.ico" "jacktrip_alt.ico" RC_CONTENTS "${RC_CONTENTS}")
    else ()
      string(REPLACE "jacktrip_alt.ico" "jacktrip.ico" RC_CONTENTS "${RC_CONTENTS}")
    endif ()
    file(WRITE "win/qjacktrip.rc" "${RC_CONTENTS}")
    set (qjacktrip_SRC ${qjacktrip_SRC} win/qjacktrip.rc)
  elseif (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
    set (qjacktrip_SRC ${qjacktrip_SRC} src/gui/NoNap.mm)
    set (CMAKE_C_FLAGS "-x objective-c")
    set (CMAKE_EXE_LINKER_FLAGS "-framework Foundation")
    if (NOT novs)
      set (CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -framework AVFoundation")
    endif ()
  endif ()
endif ()

add_compile_definitions(WAIRTOHUB)

# Tell CMake to create the executable
add_executable(jacktrip ${qjacktrip_SRC})

# Set our libraries for our linker
set (qjacktrip_LIBS ${QtVersion}::Network)
if (NOT nogui)
  set (qjacktrip_LIBS ${qjacktrip_LIBS} ${QtVersion}::Widgets)
  if (NOT novs)
    set (qjacktrip_LIBS ${qjacktrip_LIBS} ${QtVersion}::Quick ${QtVersion}::NetworkAuth ${QtVersion}::WebSockets)
  endif ()
endif ()

if (${CMAKE_SYSTEM_NAME} MATCHES "Linux" OR ${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
  if (weakjack)
    set (qjacktrip_LIBS ${qjacktrip_LIBS} dl)
  else ()
    set (qjacktrip_LIBS ${qjacktrip_LIBS} PkgConfig::JACK)
  endif ()
  if (rtaudio)
    set (qjacktrip_LIBS ${qjacktrip_LIBS} PkgConfig::RTAUDIO)
  endif ()
elseif (${CMAKE_SYSTEM_NAME} MATCHES "Windows")
  set (qjacktrip_LIBS ${qjacktrip_LIBS} ws2_32)
  if (NOT weakjack)
    set (qjacktrip_LIBS ${qjacktrip_LIBS} ${jacklib})
  endif ()
  if (rtaudio)
    set (qjacktrip_LIBS ${qjacktrip_LIBS} ${rtaudiolib})
  endif ()
endif ()

target_link_libraries(jacktrip ${qjacktrip_LIBS})

if (${CMAKE_SYSTEM_NAME} MATCHES "Linux" OR ${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
  add_custom_command(
    TARGET jacktrip POST_BUILD
    COMMAND help2man --no-info --section=1 --output=jacktrip.1 ./jacktrip
    WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
  )
endif ()

# Install the executable
install(TARGETS jacktrip DESTINATION bin)
if (${CMAKE_SYSTEM_NAME} MATCHES "Linux" OR ${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
  install(FILES ${CMAKE_BINARY_DIR}/jacktrip.1 DESTINATION share/man/man1)
endif ()

=== meson_options.txt ===
option('wair', type : 'boolean', value : 'false', description: 'WAIR')
option('rtaudio', type : 'feature', value : 'auto', description: 'Build with RtAudio Backend')
option('jack', type : 'feature', value : 'auto', description: 'Build with JACK Backend')
option('weakjack', type : 'boolean', value : 'false', description: 'Weak link JACK library')
option('nogui', type : 'boolean', value : 'false', description: 'Build without graphical user interface')
option('novs', type : 'boolean', value : 'false', description: 'Build without Virtual Studio support')
option('noupdater', type : 'boolean', value : 'false', description: 'Build without auto-update support')
option('profile', type: 'combo', choices: ['default', 'development'], value: 'default', description: 'Choose build profile / Sets desktop id accordingly')

=== debian/control ===
Source: jacktrip
Section: sound
Priority: optional
Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders:
 IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>,
Build-Depends:
 debhelper-compat (= 13),
 dh-buildinfo,
 help2man <!cross>,
 libjack-dev,
 libqt5networkauth5-dev,
 libqt5svg5-dev,
 libqt5websockets5-dev,
 librtaudio-dev,
 meson,
 pkg-config,
 python3-jinja2:native,
 python3-yaml:native,
 qtbase5-dev,
 qtdeclarative5-dev,
Standards-Version: 4.6.2
Rules-Requires-Root: no
Homepage: https://github.com/jacktrip/jacktrip/
Vcs-Git: https://salsa.debian.org/multimedia-team/jacktrip.git
Vcs-Browser: https://salsa.debian.org/multimedia-team/jacktrip

Package: jacktrip
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Suggests:
 iperf,
Description: high-quality system for audio network performances (cmdline)
 JackTrip is a Linux and Mac OS X-based system used for multi-machine
 network performance over the Internet. It supports any number of
 channels (as many as the computer/network can handle) of bidirectional,
 high quality, uncompressed audio signal streaming.
 .
 You can use it between any combination of Linux and Mac OS X systems
 (i.e., one end using Linux can connect to the other using Mac OS X).
 .
 It is currently being developed and actively tested at CCRMA by the
 SoundWIRE group.
 .
 This package contains the minimal command line version of jacktrip.

Package: jacktrip-gui
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Suggests:
 audacity,
 iperf,
 qjackctl,
Description: high-quality system for audio network performances (GUI)
 JackTrip is a Linux and Mac OS X-based system used for multi-machine
 network performance over the Internet. It supports any number of
 channels (as many as the computer/network can handle) of bidirectional,
 high quality, uncompressed audio signal streaming.
 .
 You can use it between any combination of Linux and Mac OS X systems
 (i.e., one end using Linux can connect to the other using Mac OS X).
 .
 It is currently being developed and actively tested at CCRMA by the
 SoundWIRE group.
 .
 This package contains the GUI version of jacktrip, which also includes
 RtAudio support.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

FLAVORS = cli gui
CONFIG_cli = -Dnogui=true -Drtaudio=disabled -Djack=enabled
CONFIG_gui = -Dnogui=false -Drtaudio=enabled -Djack=enabled


builddir=debian/build/flavor-

export QT_SELECT=qt5
DEB_SRCDIR = .

%:
	dh $@ --sourcedirectory=$(DEB_SRCDIR) --buildsystem=meson

#.PHONY: $(patsubst %,configure_%,$(FLAVORS))
override_dh_auto_configure-arch: $(patsubst %,configure_%,$(FLAVORS))
configure_%:
	dh_auto_configure -a -B $(builddir)$* -- $(strip $(CONFIG) $(CONFIG_$*))

#.PHONY: $(patsubst %,build_%,$(FLAVORS))
override_dh_auto_build-arch: $(patsubst %,build_%,$(FLAVORS)) $(patsubst %,$(builddir)%/jacktrip.1,$(FLAVORS))
build_%:
	dh_auto_build -a -B $(builddir)$*
	cp $(builddir)$*/jacktrip $(builddir)$*/jacktrip-$*
# manpages
$(builddir)%/jacktrip.1: build_%
	cp debian/jacktrip.1 $@
	-help2man --no-info --section=1 -n "high-quality system for audio network performances" --output $@ $(builddir)$*/jacktrip
	cp $@ $(patsubst %.1,%-$*.1,$@)

#.PHONY: $(patsubst %,test_%,$(FLAVORS))
override_dh_auto_test-arch: $(patsubst %,test_%,$(FLAVORS))
test_%:
	dh_auto_test -a -B $(builddir)$*

#.PHONY: $(patsubst %,install_%,$(FLAVORS))
override_dh_auto_install-arch: $(patsubst %,install_%,$(FLAVORS))
install_%:
	dh_auto_install -a -B $(builddir)$*
	-mv debian/tmp/usr/bin/jacktrip debian/tmp/usr/bin/jacktrip-$*
	-cp debian/jacktrip.1 debian/tmp/usr/share/man/man1/jacktrip-$*.1
	-mv debian/tmp/usr/share/man/man1/jacktrip.1 debian/tmp/usr/share/man/man1/jacktrip-$*.1
	-find debian/tmp -type f -name "*.desktop" -exec sed -e "s|^\(Exec=jacktrip\)$$|\1-$*|" -i {} ";"
install_cli:
	echo "skipping auto_install for flavour 'cli'"



override_dh_installchangelogs:
	dh_installchangelogs docs/changelog.yml


DEB_COPYRIGHT_CHECK_IGNORE_REGEX = \
        debian/.*|documentation/img/.*|docs/images/.*\.png|src/gui/.*\.png|src/gui/alt/Jacktrip\.ai|macos/jacktrip\.iconset/.*\.png|macos/JackTrip\.app_template/Contents/Resources/jacktrip\.icns|macos/jacktrip_alt\.icns
# licensecheck v1
.PHONY: licensecheck
licensecheck:
	LANG=C.UTF-8 licensecheck \
		-i "^($(DEB_COPYRIGHT_CHECK_IGNORE_REGEX))$$" \
		--check '.*' --recursive --deb-machine --lines 0 * \
		> debian/copyright_newhints
	cmp debian/copyright_hints debian/copyright_newhints \
		&& rm debian/copyright_newhints

=== debian/watch ===
# you can run the "uscan" command to check for upstream updates and more.
# See uscan(1) for format
version=4
opts=dversionmangle=auto,\
     uversionmangle=s/-pre/~pre/;s/-rc/~rc/,\
     repacksuffix=+ds,\
     filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz% \
  https://github.com/jacktrip/jacktrip/tags .*/v?(\d\S*)\.tar\.gz

## jacktrip 1.10.0+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -7,6 +7,7 @@
 set(rtaudio TRUE)
 set(weakjack TRUE)
 set(novs FALSE)
+set(vsftux FALSE)
 set(noupdater FALSE)
 set(psi FALSE)
 set(QtVersion "5")
@@ -35,6 +36,10 @@
   set(QRC_FILE "src/gui/qjacktrip_novs.qrc")
 else ()
   set(QRC_FILE "src/gui/qjacktrip.qrc")
+endif ()
+
+if (vsftux)
+  add_compile_definitions(VS_FTUX)
 endif ()
 
 if (noupdater)
@@ -155,6 +160,7 @@
   add_compile_definitions(RT_AUDIO)
   set (qjacktrip_SRC ${qjacktrip_SRC}
     src/RtAudioInterface.cpp
+    src/StereoToMono.cpp
   )
 endif ()
 
@@ -179,6 +185,10 @@
   if (NOT novs)
     set (qjacktrip_SRC ${qjacktrip_SRC}
       src/gui/virtualstudio.cpp
+      src/gui/vsApi.cpp
+      src/gui/vsAuth.cpp
+      src/gui/vsDeviceCodeFlow.cpp
+      src/gui/vsInit.cpp
       src/gui/vsQuickView.cpp
       src/gui/vsServerInfo.cpp
       src/gui/vsPing.cpp
@@ -189,6 +199,8 @@
       src/gui/vsWebSocket.cpp
       src/gui/vsPermissions.cpp
       src/gui/qjacktrip.qrc
+      src/Analyzer.cpp
+      src/Monitor.cpp
       src/Volume.cpp
       src/Tone.cpp
       # Need to include this for AUTOMOC to do its thing

=== meson_options.txt ===
--- 
+++ 
@@ -4,5 +4,7 @@
 option('weakjack', type : 'boolean', value : 'false', description: 'Weak link JACK library')
 option('nogui', type : 'boolean', value : 'false', description: 'Build without graphical user interface')
 option('novs', type : 'boolean', value : 'false', description: 'Build without Virtual Studio support')
+option('vsftux', type : 'boolean', value : 'false', description: 'Build with Virtual Studio first launch experience')
 option('noupdater', type : 'boolean', value : 'false', description: 'Build without auto-update support')
 option('profile', type: 'combo', choices: ['default', 'development'], value: 'default', description: 'Choose build profile / Sets desktop id accordingly')
+option('qtversion', type : 'combo', choices: ['5', '6'], description: 'Choose to build with either Qt5 or Qt6')

=== debian/changelog ===
jacktrip (1.10.0+ds-1) unstable; urgency=medium

  * New upstream version 1.10.0+ds
    + Drop patches applied upstream
  * Add missing sources for Simple-FFT header library
  * Update d/copyright
    * Add new files
    * Re-generate d/copyright_hints

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Mon, 19 Jun 2023 08:51:48 +0200

jacktrip (1.9.0+ds-1) unstable; urgency=medium

  * New upstream version 1.9.0+ds
  * Add B-D on qtquickcontrols2-5-dev
  * Add patch to buildsystem to allow building non-GUI jacktrip
  * Update d/copyright
    + Bump dates in d/copyright
    + Re-generate d/copyright_hints
  * Update upstream version-mangling in d/watch

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Tue, 13 Jun 2023 20:18:20 +0200

=== debian/control ===
--- 
+++ 
@@ -19,6 +19,7 @@
  python3-yaml:native,
  qtbase5-dev,
  qtdeclarative5-dev,
+ qtquickcontrols2-5-dev,
 Standards-Version: 4.6.2
 Rules-Requires-Root: no
 Homepage: https://github.com/jacktrip/jacktrip/

=== debian/rules ===
--- 
+++ 
@@ -17,6 +17,11 @@
 
 %:
 	dh $@ --sourcedirectory=$(DEB_SRCDIR) --buildsystem=meson
+
+execute_before_dh_auto_configure:
+	mkdir -p $(CURDIR)/externals/Simple-FFT/
+	cp -r $(CURDIR)/debian/missing-sources/Simple-FFT/include/ \
+		$(CURDIR)/externals/Simple-FFT/include/
 
 #.PHONY: $(patsubst %,configure_%,$(FLAVORS))
 override_dh_auto_configure-arch: $(patsubst %,configure_%,$(FLAVORS))

## jacktrip 2.2.2+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -188,14 +188,13 @@
       src/gui/vsApi.cpp
       src/gui/vsAuth.cpp
       src/gui/vsDeviceCodeFlow.cpp
-      src/gui/vsInit.cpp
+      src/gui/vsDeeplink.cpp
       src/gui/vsQuickView.cpp
       src/gui/vsServerInfo.cpp
       src/gui/vsPing.cpp
       src/gui/vsPinger.cpp
       src/gui/vsDevice.cpp
-      src/gui/vsAudioInterface.cpp
-      src/gui/vsUrlHandler.cpp
+      src/gui/vsAudio.cpp
       src/gui/vsWebSocket.cpp
       src/gui/vsPermissions.cpp
       src/gui/qjacktrip.qrc

=== meson_options.txt ===
option('wair', type : 'boolean', value : false, description: 'WAIR')
option('rtaudio', type : 'feature', value : 'auto', description: 'Build with RtAudio Backend')
option('jack', type : 'feature', value : 'auto', description: 'Build with JACK Backend')
option('weakjack', type : 'boolean', value : false, description: 'Weak link JACK library')
option('nogui', type : 'boolean', value : false, description: 'Build without graphical user interface')
option('novs', type : 'boolean', value : false, description: 'Build without Virtual Studio support')
option('vsftux', type : 'boolean', value : false, description: 'Build with Virtual Studio first launch experience')
option('noupdater', type : 'boolean', value : false, description: 'Build without auto-update support')
option('nofeedback', type : 'boolean', value : false, description: 'Build without feedback detection')
option('profile', type: 'combo', choices: ['default', 'development'], value: 'default', description: 'Choose build profile / Sets desktop id accordingly')
option('qtversion', type : 'combo', choices: ['', '5', '6'], description: 'Choose to build with either Qt5 or Qt6')
option('buildinfo', type : 'string', value : '', yield : true, description: 'Additional info used to describe the build')

=== debian/changelog ===
jacktrip (2.2.2+ds-1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 17:05:34 +1100

jacktrip (2.2.2+ds-1build1) noble; urgency=medium

  * No-change rebuild against libqt6core6t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 12 Mar 2024 01:53:02 +0000

jacktrip (2.2.2+ds-1) unstable; urgency=medium

  * New upstream version 2.2.2+ds
  * B-D on pkgconf

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Sun, 11 Feb 2024 11:12:36 +0100

jacktrip (2.2.1+ds-1) unstable; urgency=medium

  * New upstream version 2.2.1+ds

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Fri, 02 Feb 2024 00:47:12 +0100

jacktrip (2.2.0+ds-1) unstable; urgency=medium

  * New upstream version 2.2.0+ds

  * Update copyright information
    + Re-generate d/copyright_hints

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Fri, 26 Jan 2024 00:05:22 +0100

jacktrip (2.1.0+ds-1) unstable; urgency=medium

  * New upstream version 2.1.0+ds
    + Refresh patches
  * Drop obsolete jacktrip-gui-launcher wrapper-script
  * Add more B-Ds
  * Update copyright information
    + Re-generate d/copyright_hints

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Fri, 10 Nov 2023 12:28:27 +0100

jacktrip (2.0.2+ds-2) unstable; urgency=medium

  * Re-enable "VirtualStudio" on selected platforms
    + Add qml-modules required by VirtualStudio as dependencies
  * use dh_installman to install manpages
    + Patch buildsystem to not compress manpages
    + Provide dummy-manpages when cross-compiling

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Mon, 25 Sep 2023 14:08:27 +0200

jacktrip (2.0.2+ds-1) unstable; urgency=medium

  * New upstream version 2.0.2+ds
    + Drop patches applied upstream
  * Disable "Virtual Studio"

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Tue, 05 Sep 2023 23:38:57 +0200

jacktrip (2.0.1+ds-1) unstable; urgency=medium

  * New upstream version 2.0.1+ds
  * Switch to Qt6
  * Add patch to allow building without 'git' installed
  * Add patch for a more useful manpage synopsis
  * Use upstream's "install" targets
  * Use upstream manpages
    + Drop cached desktop/manpage from debian/
  * Drop local copy of Simple-FFT (now included upstream)
  * Update copyright information
    + Update copyright and licenses
    + Regenerate d/copyright_hints

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Wed, 30 Aug 2023 11:52:26 +0200

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: jacktrip
 Section: sound
 Priority: optional
-Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
 Uploaders:
  IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>,
 Build-Depends:
@@ -9,17 +10,19 @@
  dh-buildinfo,
  help2man <!cross>,
  libjack-dev,
- libqt5networkauth5-dev,
- libqt5svg5-dev,
- libqt5websockets5-dev,
  librtaudio-dev,
  meson,
- pkg-config,
+ pkgconf | pkg-config,
  python3-jinja2:native,
  python3-yaml:native,
- qtbase5-dev,
- qtdeclarative5-dev,
- qtquickcontrols2-5-dev,
+ qt6-5compat-dev,
+ qt6-base-dev,
+ qt6-declarative-dev,
+ qt6-networkauth-dev,
+ qt6-shadertools-dev,
+ qt6-svg-dev [amd64 arm64 armhf i386],
+ qt6-webengine-dev [amd64 arm64 armhf i386],
+ qt6-websockets-dev [amd64 arm64 armhf i386],
 Standards-Version: 4.6.2
 Rules-Requires-Root: no
 Homepage: https://github.com/jacktrip/jacktrip/
@@ -51,6 +54,7 @@
 Architecture: any
 Depends:
  ${misc:Depends},
+ ${qt:Depends},
  ${shlibs:Depends},
 Suggests:
  audacity,

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

FLAVORS = cli gui
CONFIG = -Djack=enabled -Dqtversion=6
CONFIG_cli = -Dnogui=true -Drtaudio=disabled
CONFIG_gui = -Dnogui=false -Drtaudio=enabled

ifeq ($(strip $(filter $(DEB_HOST_ARCH), amd64 arm64 armhf i386)),)
CONFIG += -Dnovs=true
else
QT_DEPENDS = \
	qml6-module-qt5compat-graphicaleffects, \
	qml6-module-qtqml-workerscript, \
	qml6-module-qtquick-controls, \
	qml6-module-qtquick-layouts, \
	qml6-module-qtquick-templates, \
	qml6-module-qtquick-window, \
	qml6-module-qtwebchannel, \
	qml6-module-qtwebengine
endif



builddir=debian/build/flavor-

export QT_SELECT=qt6
DEB_SRCDIR = .

%:
	dh $@ --sourcedirectory=$(DEB_SRCDIR) --buildsystem=meson

#.PHONY: $(patsubst %,configure_%,$(FLAVORS))
override_dh_auto_configure-arch: $(patsubst %,configure_%,$(FLAVORS))
configure_%:
	dh_auto_configure -a -B $(builddir)$* -- $(strip $(CONFIG) $(CONFIG_$*))

#.PHONY: $(patsubst %,build_%,$(FLAVORS))
override_dh_auto_build-arch: $(patsubst %,build_%,$(FLAVORS))
build_%:
	dh_auto_build -a -B $(builddir)$*


#.PHONY: $(patsubst %,test_%,$(FLAVORS))
override_dh_auto_test-arch: $(patsubst %,test_%,$(FLAVORS))
test_%:
	dh_auto_test -a -B $(builddir)$*

#.PHONY: $(patsubst %,install_%,$(FLAVORS))
override_dh_auto_install-arch: $(patsubst %,install_%,$(FLAVORS))
install_%:
	dh_auto_install -a -B $(builddir)$*
	-mv debian/tmp/usr/bin/jacktrip debian/tmp/usr/bin/jacktrip-$*
	# dummy manpages (for cross-compiling)
	mkdir -p debian/tmp/usr/share/man/man1/
	test -e debian/tmp/usr/share/man/man1/jacktrip.1 || cp debian/jacktrip.1 debian/tmp/usr/share/man/man1/jacktrip.1
	# flavoured manpages
	-mv debian/tmp/usr/share/man/man1/jacktrip.1 debian/tmp/usr/share/man/man1/jacktrip-$*.1
	-mv debian/tmp/usr/share/man/man1/jacktrip.1.gz debian/tmp/usr/share/man/man1/jacktrip-$*.1.gz
	-find debian/tmp -type f -name "*.desktop" -exec sed -e "s|^\(Exec=jacktrip\)$$|\1-$*|" -i {} ";"

override_dh_installchangelogs:
	dh_installchangelogs docs/changelog.yml

override_dh_gencontrol:
	dh_gencontrol -- \
		-Vqt:Depends="$(QT_DEPENDS)"



DEB_COPYRIGHT_CHECK_IGNORE_REGEX = \
        debian/.*|documentation/img/.*|docs/images/.*\.png|src/gui/.*\.png|src/gui/alt/Jacktrip\.ai|macos/jacktrip\.iconset/.*\.png|macos/JackTrip\.app_template/Contents/Resources/jacktrip\.icns|macos/jacktrip_alt\.icns
# licensecheck v1
.PHONY: licensecheck
licensecheck:
	LANG=C.UTF-8 licensecheck \
		-i "^($(DEB_COPYRIGHT_CHECK_IGNORE_REGEX))$$" \
		--check '.*' --recursive --deb-machine --lines 0 * \
		> debian/copyright_newhints
	cmp debian/copyright_hints debian/copyright_newhints \
		&& rm debian/copyright_newhints

## jacktrip 2.3.0+ds

=== debian/changelog ===
jacktrip (2.3.0+ds-1+rpi1) trixie-staging; urgency=medium

  * Remove armhf from qtwebengine architecture lists.

 -- Peter Michael Green <plugwash@raspbian.org>  Sun, 14 Jul 2024 20:22:19 +0000

jacktrip (2.3.0+ds-1) unstable; urgency=medium

  * New upstream version 2.3.0+ds
    + Refresh patches
  * Update copyright information
    + Bump copyright dates
    + Re-generate d/copyright_hints
  * Bump standards version to 4.7.0

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Fri, 17 May 2024 08:28:06 +0200

jacktrip (2.2.5+ds-1) unstable; urgency=medium

  * New upstream version 2.2.5+ds

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Tue, 02 Apr 2024 16:38:39 +0200

jacktrip (2.2.4+ds-1) unstable; urgency=medium

  * New upstream version 2.2.4+ds

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Sat, 16 Mar 2024 23:51:47 +0100

jacktrip (2.2.3+ds-1) unstable; urgency=medium

  * New upstream version 2.2.3+ds
  * Update copyright information
    + Bump dates in d/copyright
    + Re-generate d/copyright_hints

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Mon, 11 Mar 2024 08:43:32 +0100

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: jacktrip
 Section: sound
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
+Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
 Uploaders:
  IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>,
 Build-Depends:
@@ -20,10 +19,10 @@
  qt6-declarative-dev,
  qt6-networkauth-dev,
  qt6-shadertools-dev,
- qt6-svg-dev [amd64 arm64 armhf i386],
- qt6-webengine-dev [amd64 arm64 armhf i386],
- qt6-websockets-dev [amd64 arm64 armhf i386],
-Standards-Version: 4.6.2
+ qt6-svg-dev [amd64 arm64 i386],
+ qt6-webengine-dev [amd64 arm64 i386],
+ qt6-websockets-dev [amd64 arm64  i386],
+Standards-Version: 4.7.0
 Rules-Requires-Root: no
 Homepage: https://github.com/jacktrip/jacktrip/
 Vcs-Git: https://salsa.debian.org/multimedia-team/jacktrip.git

=== debian/rules ===
--- 
+++ 
@@ -10,7 +10,7 @@
 CONFIG_cli = -Dnogui=true -Drtaudio=disabled
 CONFIG_gui = -Dnogui=false -Drtaudio=enabled
 
-ifeq ($(strip $(filter $(DEB_HOST_ARCH), amd64 arm64 armhf i386)),)
+ifeq ($(strip $(filter $(DEB_HOST_ARCH), amd64 arm64 i386)),)
 CONFIG += -Dnovs=true
 else
 QT_DEPENDS = \

## jacktrip 2.4.1+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -31,11 +31,11 @@
   set(novs TRUE)
 endif ()
 
+set(QRC_FILE "src/images/images.qrc")
 if (novs)
   add_compile_definitions(NO_VS)
-  set(QRC_FILE "src/gui/qjacktrip_novs.qrc")
 else ()
-  set(QRC_FILE "src/gui/qjacktrip.qrc")
+  set(QRC_FILE "src/vs/vs.qrc")
 endif ()
 
 if (vsftux)
@@ -180,37 +180,39 @@
     src/gui/textbuf.cpp
     src/gui/vuMeter.cpp
     src/Meter.cpp
+    src/UserInterface.cpp
   )
   
   if (NOT novs)
     set (qjacktrip_SRC ${qjacktrip_SRC}
-      src/gui/virtualstudio.cpp
-      src/gui/vsApi.cpp
-      src/gui/vsAuth.cpp
-      src/gui/vsDeviceCodeFlow.cpp
-      src/gui/vsDeeplink.cpp
-      src/gui/vsQuickView.cpp
-      src/gui/vsServerInfo.cpp
-      src/gui/vsPing.cpp
-      src/gui/vsPinger.cpp
-      src/gui/vsDevice.cpp
-      src/gui/vsAudio.cpp
-      src/gui/vsWebSocket.cpp
-      src/gui/vsPermissions.cpp
-      src/gui/qjacktrip.qrc
+      src/vs/virtualstudio.cpp
+      src/vs/vsApi.cpp
+      src/vs/vsAuth.cpp
+      src/vs/vsDeviceCodeFlow.cpp
+      src/vs/vsDeeplink.cpp
+      src/vs/vsQuickView.cpp
+      src/vs/vsServerInfo.cpp
+      src/vs/vsPing.cpp
+      src/vs/vsPinger.cpp
+      src/vs/vsDevice.cpp
+      src/vs/vsAudio.cpp
+      src/vs/vsWebSocket.cpp
+      src/vs/vsPermissions.cpp
+      src/vs/vs.qrc
+      src/images/images.qrc
       src/Analyzer.cpp
       src/Monitor.cpp
       src/Volume.cpp
       src/Tone.cpp
       # Need to include this for AUTOMOC to do its thing
-      src/JTApplication.h
-      src/gui/vsQmlClipboard.h
+      src/vs/JTApplication.h
+      src/vs/vsQmlClipboard.h
     )
     if (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
-      set (qjacktrip_SRC ${qjacktrip_SRC} src/gui/vsMacPermissions.mm)
+      set (qjacktrip_SRC ${qjacktrip_SRC} src/vs/vsMacPermissions.mm)
     endif ()
   else ()
-    set (qjacktrip_SRC ${qjacktrip_SRC} src/gui/qjacktrip_novs.qrc)
+    set (qjacktrip_SRC ${qjacktrip_SRC} src/images/images.qrc)
   endif ()
   
   if (NOT noupdater)
@@ -232,7 +234,7 @@
     file(WRITE "win/qjacktrip.rc" "${RC_CONTENTS}")
     set (qjacktrip_SRC ${qjacktrip_SRC} win/qjacktrip.rc)
   elseif (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
-    set (qjacktrip_SRC ${qjacktrip_SRC} src/gui/NoNap.mm)
+    set (qjacktrip_SRC ${qjacktrip_SRC} src/NoNap.mm)
     set (CMAKE_C_FLAGS "-x objective-c")
     set (CMAKE_EXE_LINKER_FLAGS "-framework Foundation")
     if (NOT novs)

=== meson_options.txt ===
--- 
+++ 
@@ -4,9 +4,11 @@
 option('weakjack', type : 'boolean', value : false, description: 'Weak link JACK library')
 option('nogui', type : 'boolean', value : false, description: 'Build without graphical user interface')
 option('novs', type : 'boolean', value : false, description: 'Build without Virtual Studio support')
+option('noclassic', type : 'boolean', value : false, description: 'Build without classic mode support')
 option('vsftux', type : 'boolean', value : false, description: 'Build with Virtual Studio first launch experience')
 option('noupdater', type : 'boolean', value : false, description: 'Build without auto-update support')
 option('nofeedback', type : 'boolean', value : false, description: 'Build without feedback detection')
 option('profile', type: 'combo', choices: ['default', 'development'], value: 'default', description: 'Choose build profile / Sets desktop id accordingly')
 option('qtversion', type : 'combo', choices: ['', '5', '6'], description: 'Choose to build with either Qt5 or Qt6')
+option('qtedition', type : 'combo', choices: ['opensource', 'commercial'], description: 'Choose license edition for Qt')
 option('buildinfo', type : 'string', value : '', yield : true, description: 'Additional info used to describe the build')

=== debian/changelog ===
jacktrip (2.4.1+ds-1~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports.

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Wed, 30 Oct 2024 15:35:07 +0100

jacktrip (2.4.1+ds-1) unstable; urgency=medium

  * New upstream version 2.4.1+ds

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Thu, 17 Oct 2024 22:33:00 +0200

jacktrip (2.4.0+ds-1) unstable; urgency=medium

  * New upstream version 2.4.0+ds
    + Refresh patches
  * Update copyright information
    + Update d/copyright
    + Update copyright-ignore-regex
    + Re-generate d/copyright_hints

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Mon, 23 Sep 2024 00:04:20 +0200

jacktrip (2.3.1+ds-1) unstable; urgency=medium

  * New upstream version 2.3.1+ds
  * Update copyright information
    + Re-generate d/copyright_hints

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Mon, 19 Aug 2024 08:49:07 +0200

=== debian/control ===
--- 
+++ 
@@ -19,9 +19,9 @@
  qt6-declarative-dev,
  qt6-networkauth-dev,
  qt6-shadertools-dev,
- qt6-svg-dev [amd64 arm64 i386],
- qt6-webengine-dev [amd64 arm64 i386],
- qt6-websockets-dev [amd64 arm64  i386],
+ qt6-svg-dev [amd64 arm64 armhf i386],
+ qt6-webengine-dev [amd64 arm64 armhf i386],
+ qt6-websockets-dev [amd64 arm64 armhf i386],
 Standards-Version: 4.7.0
 Rules-Requires-Root: no
 Homepage: https://github.com/jacktrip/jacktrip/

=== debian/rules ===
--- 
+++ 
@@ -10,7 +10,7 @@
 CONFIG_cli = -Dnogui=true -Drtaudio=disabled
 CONFIG_gui = -Dnogui=false -Drtaudio=enabled
 
-ifeq ($(strip $(filter $(DEB_HOST_ARCH), amd64 arm64 i386)),)
+ifeq ($(strip $(filter $(DEB_HOST_ARCH), amd64 arm64 armhf i386)),)
 CONFIG += -Dnovs=true
 else
 QT_DEPENDS = \
@@ -73,7 +73,7 @@
 
 
 DEB_COPYRIGHT_CHECK_IGNORE_REGEX = \
-        debian/.*|documentation/img/.*|docs/images/.*\.png|src/gui/.*\.png|src/gui/alt/Jacktrip\.ai|macos/jacktrip\.iconset/.*\.png|macos/JackTrip\.app_template/Contents/Resources/jacktrip\.icns|macos/jacktrip_alt\.icns
+        debian/.*|documentation/img/.*|docs/images/.*\.png|src/vs/.*\.png|src/gui/.*\.png|src/gui/alt/Jacktrip\.ai|macos/jacktrip\.iconset/.*\.png|macos/JackTrip\.app_template/Contents/Resources/jacktrip\.icns|macos/jacktrip_alt\.icns
 # licensecheck v1
 .PHONY: licensecheck
 licensecheck:

## jacktrip 2.5.1%2Bds

=== build-aux/flatpak/requirements.txt ===
pyyaml
jinja2

## jacktrip 2.5.1+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,6 @@
 cmake_minimum_required(VERSION 3.12)
 set(CMAKE_OSX_DEPLOYMENT_TARGET 10.14)
+set(CMAKE_OSX_ARCHITECTURES arm64;x86_64)
 set(CMAKE_CXX_STANDARD 17)
 project(QJackTrip)
 
@@ -7,14 +8,16 @@
 set(rtaudio TRUE)
 set(weakjack TRUE)
 set(novs FALSE)
+set(nooscpp FALSE)
 set(vsftux FALSE)
 set(noupdater FALSE)
 set(psi FALSE)
-set(QtVersion "5")
+set(QtVersion "6")
 
 if (${QtVersion} MATCHES "5")
   set(CMAKE_OSX_DEPLOYMENT_TARGET 10.13)
-  set(CMAKE_OSX_ARCHITECTURES arm64;x86_64)
+elseif (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
+  list(APPEND CMAKE_PREFIX_PATH "/opt/local/libexec/qt6/lib/cmake")
 endif ()
 
 message(STATUS "Hello Aaron! For anyone else, heed the following warning:")
@@ -55,9 +58,10 @@
   endif ()
 
   file(READ "${QRC_FILE}" QRC_CONTENTS)
-  string(REPLACE "<file>about@2x.png" "<file alias=\"about@2x.png\">alt/about@2x.png" QRC_CONTENTS "${QRC_CONTENTS}")
-  string(REPLACE "<file>about.png" "<file alias=\"about.png\">alt/about.png" QRC_CONTENTS "${QRC_CONTENTS}")
-  string(REPLACE "<file>icon.png" "<file alias=\"icon.png\">alt/icon.png" QRC_CONTENTS "${QRC_CONTENTS}")
+  string(REPLACE "<file>icon_256.png" "<file alias=\"icon_256.png\">../gui/alt/icon_256.png" QRC_CONTENTS "${QRC_CONTENTS}")
+  string(REPLACE "<file alias=\"icon_128@2x.png\">icon_256.png" "<file alias=\"icon_128@2x.png\">../gui/alt/icon_256.png" QRC_CONTENTS "${QRC_CONTENTS}")
+  string(REPLACE "<file>icon_128.png" "<file alias=\"icon_128.png\">../gui/alt/icon_128.png" QRC_CONTENTS "${QRC_CONTENTS}")
+  string(REPLACE "<file>icon_32.png" "<file alias=\"icon_32.png\">../gui/alt/icon_32.png" QRC_CONTENTS "${QRC_CONTENTS}")
   file(WRITE "${QRC_FILE}" "${QRC_CONTENTS}")
   string(TIMESTAMP BUILD_DATE "%Y%m%d")
   set(BUILD_NUMBER "00")
@@ -65,9 +69,10 @@
   add_compile_definitions(NDEBUG)
 else ()
   file(READ "${QRC_FILE}" QRC_CONTENTS)
-  string(REPLACE "<file alias=\"about@2x.png\">alt/about@2x.png" "<file>about@2x.png" QRC_CONTENTS "${QRC_CONTENTS}")
-  string(REPLACE "<file alias=\"about.png\">alt/about.png" "<file>about.png" QRC_CONTENTS "${QRC_CONTENTS}")
-  string(REPLACE "<file alias=\"icon.png\">alt/icon.png" "<file>icon.png" QRC_CONTENTS "${QRC_CONTENTS}")
+  string(REPLACE "<file alias=\"icon_256.png\">../gui/alt/icon_256.png" "<file>icon_256.png" QRC_CONTENTS "${QRC_CONTENTS}")
+  string(REPLACE "<file alias=\"icon_128@2x.png\">../gui/alt/icon_256.png" "<file alias=\"icon_128@2x.png\">icon_256.png" QRC_CONTENTS "${QRC_CONTENTS}")
+  string(REPLACE "<file alias=\"icon_128.png\">../gui/alt/icon_128.png" "<file>icon_128.png" QRC_CONTENTS "${QRC_CONTENTS}")
+  string(REPLACE "<file alias=\"icon_32.png\">../gui/alt/icon_32.png" "<file>icon_32.png" QRC_CONTENTS "${QRC_CONTENTS}")
   file(WRITE "${QRC_FILE}" "${QRC_CONTENTS}")
 endif ()
 
@@ -87,7 +92,7 @@
   file(GLOB QtDirs "C:/Qt/${QtVersion}.*.*/mingw*_64")
   list(GET QtDirs 0 QtDir)
   message(STATUS "Using Qt found at ${QtDir}")
-  set (CMAKE_PREFIX_PATH "${QtDir}")
+  list(APPEND CMAKE_PREFIX_PATH "${QtDir}")
   if (rtaudio)
     include_directories("C:/Program Files (x86)/RtAudio/include")
     set (rtaudiolib "C:/Program Files (x86)/RtAudio/lib/librtaudio.dll.a")
@@ -132,6 +137,8 @@
 set(qjacktrip_SRC
   src/main.cpp
   src/Settings.cpp
+  src/SocketClient.cpp
+  src/SocketServer.cpp
   src/jacktrip_globals.cpp
   src/JackTrip.cpp
   src/UdpHubListener.cpp
@@ -139,6 +146,7 @@
   src/DataProtocol.cpp
   src/UdpDataProtocol.cpp
   src/AudioInterface.cpp
+  src/AudioSocket.cpp
   src/JackAudioInterface.cpp
   src/JMess.cpp
   src/LoopBack.cpp
@@ -146,6 +154,7 @@
   src/RingBuffer.cpp
   src/JitterBuffer.cpp
   src/Regulator.cpp
+  src/SampleRateConverter.cpp
   src/Compressor.cpp
   src/Limiter.cpp
   src/Reverb.cpp
@@ -156,6 +165,16 @@
   src/ProcessPlugin.cpp
 )
 
+if (nooscpp)
+  add_compile_definitions(NO_OSCPP)
+else ()
+  include_directories("externals/oscpp")
+  include_directories("externals/oscpp/include")
+  set (qjacktrip_SRC ${qjacktrip_SRC}
+    src/OscServer.cpp
+  )
+endif ()
+
 if (rtaudio)
   add_compile_definitions(RT_AUDIO)
   set (qjacktrip_SRC ${qjacktrip_SRC}
@@ -182,7 +201,7 @@
     src/Meter.cpp
     src/UserInterface.cpp
   )
-  
+
   if (NOT novs)
     set (qjacktrip_SRC ${qjacktrip_SRC}
       src/vs/virtualstudio.cpp
@@ -214,7 +233,7 @@
   else ()
     set (qjacktrip_SRC ${qjacktrip_SRC} src/images/images.qrc)
   endif ()
-  
+
   if (NOT noupdater)
     set (qjacktrip_SRC ${qjacktrip_SRC}
       src/dblsqd/feed.cpp

=== externals/oscpp/test/CMakeLists.txt ===
set(warnings -Wall -Wextra -Wno-unused-parameter -Werror)

add_compile_options(
  "$<$<CXX_COMPILER_ID:Clang>:${warnings}>"
  "$<$<CXX_COMPILER_ID:AppleClang>:${warnings}>"
  "$<$<CXX_COMPILER_ID:GNU>:${warnings}>"
)

# =============================================================================
# autocheck tests

add_executable(oscpp_autocheck
    oscpp_autocheck.cpp
)

target_include_directories(oscpp_autocheck PRIVATE
    ../include
    autocheck/include
)

add_test(oscpp_autocheck oscpp_autocheck)

add_custom_command(
    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/README.cpp
    COMMAND ruby ${CMAKE_CURRENT_SOURCE_DIR}/../tools/mdcode.rb
                 ${CMAKE_CURRENT_SOURCE_DIR}/../README.md
                 ${CMAKE_CURRENT_BINARY_DIR}/README.cpp
    MAIN_DEPENDENCY ${CMAKE_CURRENT_SOURCE_DIR}/../README.md
)

# =============================================================================
# README code

add_executable(oscpp_readme
  ${CMAKE_CURRENT_BINARY_DIR}/README.cpp
)

target_include_directories(oscpp_readme PRIVATE
    ../include
)

add_test(oscpp_readme oscpp_readme)

=== debian/changelog ===
jacktrip (2.5.1+ds-1) unstable; urgency=medium

  * New upstream version 2.5.1+ds
  * More upstream metadata

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Sun, 09 Feb 2025 22:10:08 +0100

jacktrip (2.5.0+ds-1) unstable; urgency=medium

  * New upstream version 2.5.0+ds
    + Refresh patches
  * Build against libsamplerate
  * Update copyright information
    + Update d/copyright
    + Re-generate copyright hints

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Mon, 27 Jan 2025 17:13:40 +0100

=== debian/control ===
--- 
+++ 
@@ -10,6 +10,7 @@
  help2man <!cross>,
  libjack-dev,
  librtaudio-dev,
+ libsamplerate-dev,
  meson,
  pkgconf | pkg-config,
  python3-jinja2:native,

=== debian/rules ===
--- 
+++ 
@@ -6,7 +6,7 @@
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 
 FLAVORS = cli gui
-CONFIG = -Djack=enabled -Dqtversion=6
+CONFIG = -Djack=enabled -Dqtversion=6 -Dlibsamplerate=enabled
 CONFIG_cli = -Dnogui=true -Drtaudio=disabled
 CONFIG_gui = -Dnogui=false -Drtaudio=enabled

=== debian/watch ===
# you can run the "uscan" command to check for upstream updates and more.
# See uscan(1) for format
version=4
opts=dversionmangle=auto,\
     uversionmangle=s/-(alpha|beta|pre|rc)/~$1/,\
     repacksuffix=+ds,\
     filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz% \
  https://github.com/jacktrip/jacktrip/tags .*/v?(\d\S*)\.tar\.gz

## jacktrip 2.7.1+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -101,7 +101,7 @@
 
 string(PREPEND QtVersion "Qt")
 
-if (${CMAKE_SYSTEM_NAME} MATCHES "Linux" OR ${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
+if (${CMAKE_SYSTEM_NAME} MATCHES "Linux" OR ${CMAKE_SYSTEM_NAME} MATCHES "Darwin" OR ${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD")
   find_package(PkgConfig REQUIRED)
   pkg_check_modules(JACK REQUIRED IMPORTED_TARGET jack)
   if (weakjack)
@@ -218,6 +218,7 @@
       src/vs/vsWebSocket.cpp
       src/vs/vsPermissions.cpp
       src/vs/vs.qrc
+      src/vs/WebSocketTransport.cpp
       src/images/images.qrc
       src/Analyzer.cpp
       src/Monitor.cpp

=== meson_options.txt ===
--- 
+++ 
@@ -2,8 +2,10 @@
 option('rtaudio', type : 'feature', value : 'auto', description: 'Build with RtAudio Backend')
 option('jack', type : 'feature', value : 'auto', description: 'Build with JACK Backend')
 option('weakjack', type : 'boolean', value : false, description: 'Weak link JACK library')
+option('libsamplerate', type : 'feature', value : 'auto', description: 'Support for sample rate conversions')
 option('nogui', type : 'boolean', value : false, description: 'Build without graphical user interface')
 option('novs', type : 'boolean', value : false, description: 'Build without Virtual Studio support')
+option('nooscpp', type : 'boolean', value : false, description: 'Build without OSC support')
 option('noclassic', type : 'boolean', value : false, description: 'Build without classic mode support')
 option('vsftux', type : 'boolean', value : false, description: 'Build with Virtual Studio first launch experience')
 option('noupdater', type : 'boolean', value : false, description: 'Build without auto-update support')
@@ -12,3 +14,7 @@
 option('qtversion', type : 'combo', choices: ['', '5', '6'], description: 'Choose to build with either Qt5 or Qt6')
 option('qtedition', type : 'combo', choices: ['opensource', 'commercial'], description: 'Choose license edition for Qt')
 option('buildinfo', type : 'string', value : '', yield : true, description: 'Additional info used to describe the build')
+option('vst-libdir', type : 'string', value : '', yield : true,
+  description : 'Directory with VST SDK3 libraries (e.g. libsdk.a, libbase.a)')
+option('vst-sdkdir', type : 'string', value : '', yield : true,
+  description : 'Directory with VST SDK3 headers (e.g. public.sdk/source/vst/hosting/module.h)')

=== docs/requirements.txt ===
mkdocs-material
mkdocs-macros-plugin

=== externals/oscpp/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.9)
project(oscpp VERSION 0.3.0)

if (CMAKE_SYSTEM_NAME STREQUAL "Linux")
    set(LINUX TRUE)
endif ()

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_C_STANDARD 99)

enable_testing()

add_subdirectory(test)

=== externals/oscpp/Makefile ===
.PHONY: build clean distclean test v verbose

NINJA_FLAGS = $(args)

ifeq (1,$(or $(verbose),$(v)))
NINJA_FLAGS += -v
endif

build: build/CMakeCache.txt
	cd build && ninja $(NINJA_FLAGS)

v: verbose

verbose: NINJA_FLAGS += -v
verbose: build

build/CMakeCache.txt:
	mkdir -p build
	cd build && cmake -G Ninja ..

clean:
	cd build && ninja clean

distclean:
	rm -rf build

test: build
	cd build && ctest -V

=== debian/changelog ===
jacktrip (2.7.1+ds-1) unstable; urgency=medium

  * New upstream version 2.7.1+ds
    (Closes: #1096869)
    + Drop obsolete patches
    + Refresh patches
  * Drop alternative B-D on obsolete pkg-config
  * Update copyright information
    + Bump copyright dates
    + Update exclude rules for licensecheck target
    + Re-generate copyright hints
  * Bump standards version to 4.7.2

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Fri, 22 Aug 2025 12:57:35 +0200

=== debian/control ===
--- 
+++ 
@@ -6,13 +6,12 @@
  IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>,
 Build-Depends:
  debhelper-compat (= 13),
- dh-buildinfo,
  help2man <!cross>,
  libjack-dev,
  librtaudio-dev,
  libsamplerate-dev,
  meson,
- pkgconf | pkg-config,
+ pkgconf,
  python3-jinja2:native,
  python3-yaml:native,
  qt6-5compat-dev,
@@ -23,7 +22,7 @@
  qt6-svg-dev [amd64 arm64 armhf i386],
  qt6-webengine-dev [amd64 arm64 armhf i386],
  qt6-websockets-dev [amd64 arm64 armhf i386],
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Homepage: https://github.com/jacktrip/jacktrip/
 Vcs-Git: https://salsa.debian.org/multimedia-team/jacktrip.git

=== debian/rules ===
--- 
+++ 
@@ -73,7 +73,7 @@
 
 
 DEB_COPYRIGHT_CHECK_IGNORE_REGEX = \
-        debian/.*|documentation/img/.*|docs/images/.*\.png|src/vs/.*\.png|src/gui/.*\.png|src/gui/alt/Jacktrip\.ai|macos/jacktrip\.iconset/.*\.png|macos/JackTrip\.app_template/Contents/Resources/jacktrip\.icns|macos/jacktrip_alt\.icns
+        debian/.*|documentation/img/.*|docs/images/.*\.png|src/vs/.*\.png|src/images/.*\.png|src/images/jacktrip\.icns|src/gui/alt/.*\.png|src/gui/alt/Jacktrip\.ai|macos/jacktrip(_alt)?\.iconset/.*\.png|macos/jacktrip_alt\.icns
 # licensecheck v1
 .PHONY: licensecheck
 licensecheck:
